<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\model;

/**
 * Description of produtos
 *
 * @author alfamidia
 */
class negociacoes {
    private $lista;
    private $detalhe;
    
    private $produtos;
    private $detalhe_produto;
    private $PDO;
    private $ultimo_erro;
    
    public function Conexao() {
        try {
           $this->PDO = new \PDO("mysql:host=localhost;dbname=crm","root");
        } 
        catch (\PDOException $exc) {
            $this->ultimo_erro = "erro na conexão<br>";
            return false;
        }
        return true;
    }

    public function Listar($idClientes) {
        
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        //NOVO 1: Ordenado por data. Lendo e armazenando a data
        $sql = "SELECT data, idNegociacoes, titulo, funil FROM negociacoes WHERE clientes_idclientes = ? ORDER BY data DESC";
        $retorno = $this->PDO->prepare($sql);
        $retorno->bindParam(1,$idClientes);
        $retorno->execute();
        $i = 0;
        while($resultado = $retorno->fetch()) {  
            $this->lista[$i]['data'] = $resultado['data'];
            $this->lista[$i]['idNegociacoes'] = $resultado['idNegociacoes'];
            $this->lista[$i]['titulo'] = $resultado['titulo'];
            $this->lista[$i]['funil'] = $resultado['funil'];
            
            $i++;
            
        }     
        return $this->lista;

    }
    
    public function Remover($idNegociacoes) {
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        
        $sql = "DELETE FROM negociacoes WHERE idNegociacoes= ?";
        $retorno = $this->PDO->prepare($sql);
        $retorno->bindParam(1,$idNegociacoes);
        $retorno->execute();
        
    }
    
    
    public function LerDetalhe($idNegociacoes) {
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        
        $sql = "SELECT data,titulo,relato,funil FROM negociacoes WHERE idnegociacoes = ?";
        $retorno = $this->PDO->prepare($sql);
        $retorno->bindParam(1,$idNegociacoes);      
        $retorno->execute();
        $resultado = $retorno->fetch();
        $this->detalhe['data'] = $resultado['data'];
        $this->detalhe['titulo'] = $resultado['titulo'];
        $this->detalhe['relato'] = $resultado['relato'];
        $this->detalhe['funil'] = $resultado['funil'];
        
        return $this->detalhe;
        
    }
    
    public function Atualizar($idNegociacoes,$entrada){
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        
        $retorno = $this->PDO->prepare('UPDATE negociacoes '
                . 'SET data = :data, '
                . 'titulo= :titulo, '
                . 'relato= :relato '
                . 'WHERE idNegociacoes = :id');
        $retorno->bindParam(':data',$entrada['data']);
        $retorno->bindParam(':titulo',$entrada['titulo']);
        $retorno->bindParam(':relato',$entrada['relato']);
        $retorno->bindParam(':id',$idNegociacoes);
        $retorno->execute();
    }

    public function Incluir($entrada){
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        $retorno = $this->PDO->prepare('INSERT INTO negociacoes (data, datainicial,funil,titulo,relato,clientes_idClientes) values (:data, :datainicial,:funil, :titulo,:relato,:idClientes)');
        $retorno->bindParam(':data',$entrada["data"]);
        $retorno->bindParam(':datainicial',$entrada["datainicial"]);
        $retorno->bindParam(':funil',$entrada["funil"]);
        $retorno->bindParam(':titulo',$entrada["titulo"]);
        $retorno->bindParam(':relato',$entrada["relato"]);
        $retorno->bindParam(':idClientes',$entrada["idClientes"]);
        $this->PDO->beginTransaction();
        $retorno->execute();
        $idGerado = $this->PDO->lastInsertId();
        $this->PDO->commit();
        return $idGerado;
    }
    

    public function RetornaNegociacoes($idClientes) {
        $this->LerNegociacoes($idClientes);
        return $this->lista;
    }
}
