<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\model;

/**
 * Description of produtos
 *
 * @author alfamidia
 */
class observacoes {
    private $lista;
    private $detalhe;
    private $PDO;
    private $ultimo_erro;
    
    public function Conexao() {
        try {
           $this->PDO = new \PDO("mysql:host=localhost;dbname=crm","root");
        } 
        catch (\PDOException $exc) {
            $this->ultimo_erro = "erro na conexão<br>";
            return false;
        }
        return true;
    }

    public function Listar($idClientes) {
        
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        //NOVO 1: Ordenado por data. Lendo e armazenando a data
        $sql = "SELECT data, idObservacoes, titulo FROM observacoes WHERE clientes_idclientes = ? ORDER BY data DESC";
        $retorno = $this->PDO->prepare($sql);
        $retorno->bindParam(1,$idClientes);
        $retorno->execute();
        $i = 0;
        while($resultado = $retorno->fetch()) {  
            $this->lista[$i]['data'] = $resultado['data'];
            $this->lista[$i]['idObservacoes'] = $resultado['idObservacoes'];
            $this->lista[$i]['titulo'] = $resultado['titulo'];
            $i++;
        } 
        return $this->lista;
    }
    
    public function Remover($idObservacoes) {
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        
        $sql = "DELETE FROM observacoes WHERE idObservacoes= ?";
        $retorno = $this->PDO->prepare($sql);
        $retorno->bindParam(1,$idObservacoes);
        $retorno->execute();
        
    }
    
    
    public function LerDetalhe($idObservacoes) {
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        
        $sql = "SELECT data,titulo,relato FROM observacoes WHERE idobservacoes = ?";
        $retorno = $this->PDO->prepare($sql);
        $retorno->bindParam(1,$idObservacoes);      
        $retorno->execute();
        $resultado = $retorno->fetch();
        $this->detalhe['data'] = $resultado['data'];
        $this->detalhe['titulo'] = $resultado['titulo'];
        $this->detalhe['relato'] = $resultado['relato'];
        
        return $this->detalhe;
        
    }
    
    public function Atualizar($idObservacoes, $entrada){
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        
        $retorno = $this->PDO->prepare('UPDATE observacoes '
                . 'SET data = :data, '
                . 'titulo= :titulo, '
                . 'relato= :relato '
                . 'WHERE idObservacoes = :id');
        $retorno->bindParam(':data',$entrada['data']);
        $retorno->bindParam(':titulo',$entrada['titulo']);
        $retorno->bindParam(':relato',$entrada['relato']);
        $retorno->bindParam(':id',$idObservacoes);
        $retorno->execute();
    }

    public function IncluirObservacoes($titulo, $entrada){
        if (!$this->Conexao()){
            echo "Erro de conexão<BR>";
            echo $this->ultimo_erro;
            return;
        }
        $retorno = $this->PDO->prepare('INSERT INTO observacoes (data,titulo,relato,clientes_idClientes) values (:data, :titulo,:relato,:idClientes)');
        $retorno->bindParam(':data',$entrada['data']);
        $retorno->bindParam(':titulo',$entrada['titulo']);
        $retorno->bindParam(':relato',$entrada['relato']);
        $retorno->bindParam(':idClientes',$idClientes);
        $this->PDO->beginTransaction();
        $retorno->execute();
        $idGerado = $this->PDO->lastInsertId();
        $this->PDO->commit();
        return $idGerado;
    }

    public function RetornaObservacoes($idClientes) {
        $this->LerObservacoes($idClientes);
        return $this->lista;
    }
}
